Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Cryptix V3.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## cryptix.provider.key
Class IDEAKeyGenerator

    java.lang.Object
      |
      +--xjava.security.KeyGenerator
            |
            +--cryptix.provider.key.RawKeyGenerator
                  |
                  +--cryptix.provider.key.IDEAKeyGenerator

public class IDEAKeyGenerator
extends RawKeyGenerator

A key generator for IDEA.

IDEA keys have a fixed length of 128 bits.

References:

Copyright © 1997 Systemics Ltd on behalf of the Cryptix Development Team.
All rights reserved.

$Revision: 1.1.1.1 $

Since:
  Cryptix 2.2.0a, 2.2.2
Author:
  David Hopwood

Constructor Summary
`IDEAKeyGenerator()`

Method Summary
`boolean` | `isWeak(byte[] key)` Returns true iff the byte array key represents a weak IDEA key.

Methods inherited from class cryptix.provider.key.RawKeyGenerator
`engineGenerateKey, generateKey, generateKey, getDefaultKeyLength, getMaximumKeyLength, getMinimumKeyLength, initialize, initialize, isValidKeyLength, isWeakAllowed, setWeakAllowed`

Methods inherited from class xjava.security.KeyGenerator
`clone, engineGetParameter, engineSetParameter, getAlgorithm, getAlgorithms, getAlgorithms, getInstance, getInstance, getParameter, setParameter, toString`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### IDEAKeyGenerator

    public IDEAKeyGenerator()

Method Detail

### isWeak

    public boolean isWeak(byte[] key)

  Returns true iff the byte array key represents a weak IDEA key.

  IDEA has two non-overlapping classes of weak keys (bit numbering is from left to right, e.g. 0 denotes the most significant bit of the first byte):

  - Keys with zeros in bit positions 0-25, 29-71, and 75-110 (inclusive) and any value in bits 26-28, 72-74, and 111-127. There are 2^23 weak keys in this class.

  - Keys with zeros in bit positions 0-25, 41-71, 84-98, and 123-127 and any value in bit positions 26-40, 72-83, and 99-122. There are 2^51 weak keys in this class.
  Overrides:
    isWeak in class RawKeyGenerator
  Parameters:
    `key` - the byte array containing user key data.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Cryptix V3.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) 1995-2000 The Cryptix Foundation Ltd. All rights reserved.